/*
 * (C) Copyright 2014 Freescale Semiconductor, Inc.
 *
 * SPDX-License-Identifier:	GPL-2.0+
 */

static const u8 int_routing_conf[] = {
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* DMA0 Transfer Complete CH0-31 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* DMA0 Error Interrupt CH0-31 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* DMA1 Transfer Complete CH0-31 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* DMA1 Transfer Complete CH0-31 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* SWT 0 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* SWT 1 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* SWT 2 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* MSCM-ECC0 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* MSCM-ECC1 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* xRDC */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* MSCM-ACTZS */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* STM 0 */
	MSCM_IRSPRC_ROUTE_TO_CA7,
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* WDOG-SNVS */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* SNVS - Non TZ*/
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* SNVS - TZ */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* QuadSPI0 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* MMDC */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* NFC */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* USDHC0 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* USDHC1 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* USDHC 2 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* MIPI-CSI2 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* DCU0 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* VIU */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* VPU */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* GC400T */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* RLE */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* USBC 0*/
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* USBC 1 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* USBC 2 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* PIT */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* LPTimer */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* SPDIF1 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/*FlexTimer  */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* ENET 0 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* 1588 Timer 0 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* VSPA */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* FECA */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* AXIQ */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* JESD204B 0/1 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* JESD204B 2/3 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* ANADIG - USB PHY 0 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* ANADIG - USB PHY 1 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* ENET 0 errors */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* ADC 0 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* AUD_ADC_DAC */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* ENET Queue 0 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* ENET Queues  */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* FlexCAN 0 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* FlexCAN 1 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* FlexCAN 2 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* MLB */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* UART 0 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* UART 1 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* UART 2 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* UART 3 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* UART 4 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* UART 5 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* SPI 0 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* SPI 1 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* VSPA-GPO11[24] */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* VSPA-GPO11[25] */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* I2C 0 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* I2C 1 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* I2C 2 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* I2C 3 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* SAI 0 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* SAI 1 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* SAI 2 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* SAI 3 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* SAI 4 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* SAI 5 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* SAI 6 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* SAI 7 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* SAI 8 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* SAI 9 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* SAI 10 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* SAI 11 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* ESAI0 BIFIFO */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* ESAI1 BIFIFO */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* SPDIF0 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* ASRC0 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* ASRC1 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* SRC */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* WKUP 0 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* GPC */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* Temp Sensor */
	MSCM_IRSPRC_ROUTE_TO_CA7,
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* PDB */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* CMU */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* CAAM */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* GPIO 0 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* GPIO 1 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* GPIO 2 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* GPIO 3 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* GPIO 4 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* GPIO 5 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* GPIO 6 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* GPIO 7 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* GPIO 8 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* GPIO 9 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* GPIO 10 */
	MSCM_IRSPRC_ROUTE_TO_CA7,
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* JESD204B_0 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* JESD204B_1 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* JESD204B_2 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* JESD204B_3 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* ENET Queue 1 */
	MSCM_IRSPRC_ROUTE_TO_CA7,	/* ENET Queue 2 */
	MSCM_IRSPRC_ROUTE_TO_CA7,
	MSCM_IRSPRC_ROUTE_TO_CA7,
};

